//Source file: PAMADEventData.java
//Date: February 2004
//Presence and Availability Management Data Types for 3GPP TS 29.198-14 V6.0.0, Release 6

package org.csapi.jr.se.pam;

/**
 * This is a Sequence of Data Elements to specify the input data for subscribing to agent deletions. The event is registered for changes in any of the named agents. If no agents are named, then the event is registered for all agents.
 * 
 */
public final class PAMADEventData implements java.io.Serializable {

    private String[] agentName;
    private String[] agentType;

    /**
     * Creates a new PAMADEventData instance.
     */
    public PAMADEventData () {}

    /**
     * Creates a new PAMADEventData instance.
     * @param _agentName   Specifies the name of the agent whose deletion is to be notified. Can be an empty array.
     * @param _agentType   Specifies the type of the agent for which this notification is requested if agentName is an empty array. Can be an empty array if notification required for agents of any type.
     */
    public PAMADEventData (String[] _agentName, String[] _agentType) {

        this.agentName = _agentName;
        this.agentType = _agentType;
    }

    /**
     * This method returns a agentName.
     * 
     * @return a String[] value
     */
    public String[] getAgentName() {
        return agentName;
    }

    /**
     * This method returns a agentType.
     * 
     * @return a String[] value
     */
    public String[] getAgentType() {
        return agentType;
    }


    /**
     * This method sets a agentName.
     */ 
    public void setAgentName(String[] agentName) {
        this.agentName = agentName;
    }

    /**
     * This method sets a agentType.
     */ 
    public void setAgentType(String[] agentType) {
        this.agentType = agentType;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof PAMADEventData)) {
            return false;
        } 
        PAMADEventData pAMADEventData = (PAMADEventData) o;
        if(!(this.agentName == pAMADEventData.agentName))  {
            return false;
        }
        if(!(this.agentType == pAMADEventData.agentType))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PAMADEventData

