//Source file: PAMContextName.java
//Date: February 2004
//Presence and Availability Management Data Types for 3GPP TS 29.198-14 V6.0.0, Release 6

package org.csapi.jr.se.pam;

/**
 * This specifies the availability contexts. 
 *
 */
public final class PAMContextName implements java.io.Serializable {

    private int _value;
    private static int _size = 2;
    private static PAMContextName[] _array = new PAMContextName[_size];

    /**
     * Private constructor used internally to construct static objects 
     */
    private PAMContextName(int value) {
        _value = value;
        _array[_value] = this;
    }

    /**
     * Denotes any known context
     */
    public static final int _PAM_CONTEXT_ANY =  0;

    /**
     * Denotes any known context
     */
    public static final PAMContextName PAM_CONTEXT_ANY = new PAMContextName(_PAM_CONTEXT_ANY);

    /**
     * Denotes a communication context
     */
    public static final int _PAM_CONTEXT_COMMUNICATION =  1;

    /**
     * Denotes a communication context
     */
    public static final PAMContextName PAM_CONTEXT_COMMUNICATION = new PAMContextName(_PAM_CONTEXT_COMMUNICATION);


    /**
     * Number representing enum type
     *
     * @return int number representing type of object, this is defined within the class
     */
    public int getValue() {
        return _value;
    }

    /**
     * getValueText method, overrides the getValueText() method in class java.lang.Object
     *
     * @return String  The stringified version of the PAMContextName object
     */
    public String getValueText() {
        switch (_value) {
            case _PAM_CONTEXT_ANY:
                return "PAM_CONTEXT_ANY";
            case _PAM_CONTEXT_COMMUNICATION:
                return "PAM_CONTEXT_COMMUNICATION";
            default:
                return "ERROR";
        }
    }

    /**
     * Accepts values in the range of 0 to 1
     *
     * @param value number representing type of object, this is defined within the class
     * @throws org.csapi.jr.se.InvalidEnumValueException thrown if invalid value is passed into method
     */
    public static PAMContextName getObject(int value) throws org.csapi.jr.se.InvalidEnumValueException {
        if(value >= 0 && value < _size) {
            return _array[value];
        } else {
            throw new org.csapi.jr.se.InvalidEnumValueException("value [" + value +" ] out of range");
        }
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof PAMContextName)) {
            return false;
        }
        PAMContextName pAMContextName = (PAMContextName) o; 
        if(!(this.getValue() == pAMContextName.getValue())) {
            return false;
        }
        if (this.hashCode() != pAMContextName.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PAMContextName

