//Source file: PAMIDNotificationData.java
//Date: February 2004
//Presence and Availability Management Data Types for 3GPP TS 29.198-14 V6.0.0, Release 6

package org.csapi.jr.se.pam;

/**
 * This is a Sequence of Data Elements to specify the data that is provided in the notifications for identity deletion events.
 * 
 */
public final class PAMIDNotificationData implements java.io.Serializable {

    private String[] identities;

    /**
     * Creates a new PAMIDNotificationData instance.
     */
    public PAMIDNotificationData () {}

    /**
     * Creates a new PAMIDNotificationData instance.
     * @param _identities   Contains the names of the identities that have been deleted.
     */
    public PAMIDNotificationData (String[] _identities) {

        this.identities = _identities;
    }

    /**
     * This method returns a identities.
     * 
     * @return a String[] value
     */
    public String[] getIdentities() {
        return identities;
    }


    /**
     * This method sets a identities.
     */ 
    public void setIdentities(String[] identities) {
        this.identities = identities;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof PAMIDNotificationData)) {
            return false;
        } 
        PAMIDNotificationData pAMIDNotificationData = (PAMIDNotificationData) o;
        if(!(this.identities == pAMIDNotificationData.identities))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PAMIDNotificationData

