//Source file: PAMIPSNotificationData.java
//Date: February 2004
//Presence and Availability Management Data Types for 3GPP TS 29.198-14 V6.0.0, Release 6

package org.csapi.jr.se.pam;

/**
 * This is a Sequence of Data Elements to specify the data that is provided in the notifications for identity presence set events.
 * 
 */
public final class PAMIPSNotificationData implements java.io.Serializable {

    private String identity;
    private org.csapi.jr.se.pam.PAMPresenceData[] attributes;

    /**
     * Creates a new PAMIPSNotificationData instance.
     */
    public PAMIPSNotificationData () {}

    /**
     * Creates a new PAMIPSNotificationData instance.
     * @param _identity   Contains the name of the identity whose capability has changed.
     * @param _attributes   Contains the attributes that have changed in value.
     */
    public PAMIPSNotificationData (String _identity, org.csapi.jr.se.pam.PAMPresenceData[] _attributes) {

        this.identity = _identity;
        this.attributes = _attributes;
    }

    /**
     * This method returns a identity.
     * 
     * @return a String value
     */
    public String getIdentity() {
        return identity;
    }

    /**
     * This method returns a attributes.
     * 
     * @return a org.csapi.jr.se.pam.PAMPresenceData[] value
     */
    public org.csapi.jr.se.pam.PAMPresenceData[] getAttributes() {
        return attributes;
    }


    /**
     * This method sets a identity.
     */ 
    public void setIdentity(String identity) {
        this.identity = identity;
    }

    /**
     * This method sets a attributes.
     */ 
    public void setAttributes(org.csapi.jr.se.pam.PAMPresenceData[] attributes) {
        this.attributes = attributes;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof PAMIPSNotificationData)) {
            return false;
        } 
        PAMIPSNotificationData pAMIPSNotificationData = (PAMIPSNotificationData) o;
        if(!(this.identity == pAMIPSNotificationData.identity))  {
            return false;
        }
        if(!(this.attributes == pAMIPSNotificationData.attributes))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // PAMIPSNotificationData

