//Source file: PamUnknownAttributeException.java
//Date: February 2004
//Presence and Availability Management Data Types for 3GPP TS 29.198-14 V6.0.0, Release 6

package org.csapi.jr.se.pam;

/**
 * Indicates that at least one of the specified attributes has not been defined or has not been associated with the specified object
 *
 */
public class PamUnknownAttributeException extends org.csapi.jr.se.pam.PamException {

    private Throwable _cause = null;

    public PamUnknownAttributeException() {
        super(); 
    }

    public PamUnknownAttributeException(String message) {
        super(message); 
    }

    public PamUnknownAttributeException(String message, Throwable cause) {
        super(message); 
        _cause = cause;
    }

    public PamUnknownAttributeException(Throwable cause) {
        _cause = cause; 
    }

    public Throwable getCause() {
        return _cause;
    } 

} // PamUnknownAttributeException

