//Source file: AppInterface.java
//Date: February 2004
//Presence and Availability Management Interfaces for 3GPP TS 29.198-14 V6.0.0, Release 6

package org.csapi.jr.se.pam.event;

/**
 * This interface represents a AppInterface activity object.<BR>
 *
 */
public interface AppInterface extends org.csapi.jr.se.Activity {

    /**
     * Returns a reference to the PAMEventHandler responsible for creation of the AppInterface.
     *
     * @return  A reference to the PAMEventHandler responsible for creation of the AppInterface.
     */
    org.csapi.jr.se.pam.event.PAMEventHandler getPAMEventHandler();

    /**
     * Adds a AppInterfaceListener which is interested in events generated by the AppInterface.
     *
     * @param  appInterfaceListener  A reference to the AppInterfaceListener which is to be added as
     *        a listener.
     */
    void addAppInterfaceListener(org.csapi.jr.se.pam.event.AppInterfaceListener appInterfaceListener);

    /**
     * Removes a AppInterfaceListener which is no longer interested events generated by the AppInterface.
     *
     * @param  appInterfaceListener  A reference to the AppInterfaceListener which is to be removed as
     *        a listener.
     */
    void removeAppInterfaceListener(org.csapi.jr.se.pam.event.AppInterfaceListener appInterfaceListener);

    /**
     * Invokes the registerAppInterface() method on the Parlay Gateway.
     */
    void registerAppInterface(
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       java.lang.IllegalStateException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;
}
