//Source file: EventNotifyEvent.java
//Date: February 2004
//Presence and Availability Management Interfaces for 3GPP TS 29.198-14 V6.0.0, Release 6

package org.csapi.jr.se.pam.event;

/**
 * Event created by an activity object to indicate that a Gateway originated 
 * call to the eventNotify() method on the callback interface 
 * has occured.<BR>
 *
 */
public final class EventNotifyEvent extends java.util.EventObject {

    /**
     * Constructor for the EventNotifyEvent Event.
     *
     * @param  source      Reference to the object firing the event.<BR>
     */
    public EventNotifyEvent(java.lang.Object source,
        int                             eventID,
        org.csapi.jr.se.pam.PAMNotificationInfo[] eventInfo) {

        super(source);
      this.eventID = eventID;
      this.eventInfo = eventInfo;
 
    }

    int                             eventID;

    /**
     *  This method is used to retrieve the parameter value of 'eventID' passed up
     *  from the Gateway in it's call to the eventNotify() method, used on
     *  the creation of this event.
     *
     * @return    The value of 'eventID' used on creation of this event.
     */
    public int getEventID() {

        return this.eventID;
    }
       
    org.csapi.jr.se.pam.PAMNotificationInfo[] eventInfo;

    /**
     *  This method is used to retrieve the parameter value of 'eventInfo' passed up
     *  from the Gateway in it's call to the eventNotify() method, used on
     *  the creation of this event.
     *
     * @return    The value of 'eventInfo' used on creation of this event.
     */
    public org.csapi.jr.se.pam.PAMNotificationInfo[] getEventInfo() {

        return this.eventInfo;
    }
       
}

