//Source file: PAMAgentAssignment.java
//Date: February 2004
//Presence and Availability Management Interfaces for 3GPP TS 29.198-14 V6.0.0, Release 6

package org.csapi.jr.se.pam.provisioning;

/**
 * This interface represents a PAMAgentAssignment.<BR>
 *
 */
public interface PAMAgentAssignment extends org.csapi.jr.se.Service {

    /**
     * Invokes the assignAgent() method on the Parlay Gateway.
     */
    void assignAgent(
           java.lang.String                identity,
           java.lang.String                agentName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the unassignAgent() method on the Parlay Gateway.
     */
    void unassignAgent(
           java.lang.String                identity,
           java.lang.String                agentName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamUnknownAssignmentException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listAssignedAgents() method on the Parlay Gateway.
     */
    java.lang.String[] listAssignedAgents(
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listAssociatedIdentitiesOfAgent() method on the Parlay Gateway.
     */
    java.lang.String[] listAssociatedIdentitiesOfAgent(
           java.lang.String                agentName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAgentException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listAssignedAgentsByCapability() method on the Parlay Gateway.
     */
    java.lang.String[] listAssignedAgentsByCapability(
           java.lang.String                identity,
           java.lang.String                capability,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listCapabilitiesOfIdentity() method on the Parlay Gateway.
     */
    java.lang.String[] listCapabilitiesOfIdentity(
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the isIdentityCapableOf() method on the Parlay Gateway.
     */
    boolean isIdentityCapableOf(
           java.lang.String                identity,
           java.lang.String                capability,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

}
