//Source file: PAMAgentTypeManagement.java
//Date: February 2004
//Presence and Availability Management Interfaces for 3GPP TS 29.198-14 V6.0.0, Release 6

package org.csapi.jr.se.pam.provisioning;

/**
 * This interface represents a PAMAgentTypeManagement.<BR>
 *
 */
public interface PAMAgentTypeManagement extends org.csapi.jr.se.Service {

    /**
     * Invokes the createAgentAttribute() method on the Parlay Gateway.
     */
    void createAgentAttribute(
           org.csapi.jr.se.pam.PAMAttributeDef pAttribute,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamAttributeExistsException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the deleteAgentAttribute() method on the Parlay Gateway.
     */
    void deleteAgentAttribute(
           java.lang.String                attributeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the getAgentAttributeDefinition() method on the Parlay Gateway.
     */
    org.csapi.jr.se.pam.PAMAttributeDef getAgentAttributeDefinition(
           java.lang.String                attributeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listAllAgentAttributes() method on the Parlay Gateway.
     */
    java.lang.String[] listAllAgentAttributes(
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the createAgentType() method on the Parlay Gateway.
     */
    void createAgentType(
           java.lang.String                typeName,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamTypeExistsException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the deleteAgentType() method on the Parlay Gateway.
     */
    void deleteAgentType(
           java.lang.String                typeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listAgentTypes() method on the Parlay Gateway.
     */
    java.lang.String[] listAgentTypes(
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the addAgentTypeAttributes() method on the Parlay Gateway.
     */
    void addAgentTypeAttributes(
           java.lang.String                typeName,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamAttributeExistsException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the removeAgentTypeAttributes() method on the Parlay Gateway.
     */
    void removeAgentTypeAttributes(
           java.lang.String                typeName,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listAgentTypeAttributes() method on the Parlay Gateway.
     */
    java.lang.String[] listAgentTypeAttributes(
           java.lang.String                typeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

}
