//Source file: PAMIdentityManagement.java
//Date: February 2004
//Presence and Availability Management Interfaces for 3GPP TS 29.198-14 V6.0.0, Release 6

package org.csapi.jr.se.pam.provisioning;

/**
 * This interface represents a PAMIdentityManagement.<BR>
 *
 */
public interface PAMIdentityManagement extends org.csapi.jr.se.Service {

    /**
     * Invokes the createIdentity() method on the Parlay Gateway.
     */
    void createIdentity(
           java.lang.String                identity,
           java.lang.String[]              identityTypes,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamIdentityExistsException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the deleteIdentity() method on the Parlay Gateway.
     */
    void deleteIdentity(
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the isIdentity() method on the Parlay Gateway.
     */
    boolean isIdentity(
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the createGroupIdentity() method on the Parlay Gateway.
     */
    void createGroupIdentity(
           java.lang.String                identity,
           java.lang.String[]              identityTypes,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamIdentityExistsException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the deleteGroupIdentity() method on the Parlay Gateway.
     */
    void deleteGroupIdentity(
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the addToGroup() method on the Parlay Gateway.
     */
    void addToGroup(
           java.lang.String                group,
           java.lang.String                member,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamMemberExistsException,
       org.csapi.jr.se.pam.PamUnknownGroupException,
       org.csapi.jr.se.pam.PamUnknownMemberException,
       org.csapi.jr.se.pam.PamIsCyclicException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the removeFromGroup() method on the Parlay Gateway.
     */
    void removeFromGroup(
           java.lang.String                group,
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamNotMemberException,
       org.csapi.jr.se.pam.PamUnknownGroupException,
       org.csapi.jr.se.pam.PamUnknownMemberException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listMembers() method on the Parlay Gateway.
     */
    java.lang.String[] listMembers(
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownGroupException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the isGroupIdentity() method on the Parlay Gateway.
     */
    boolean isGroupIdentity(
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listGroupMembership() method on the Parlay Gateway.
     */
    java.lang.String[] listGroupMembership(
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the addAlias() method on the Parlay Gateway.
     */
    void addAlias(
           java.lang.String                identity,
           java.lang.String                alias,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamAliasExistsException,
       org.csapi.jr.se.pam.PamAliasNotUniqueException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the removeAliases() method on the Parlay Gateway.
     */
    void removeAliases(
           java.lang.String                identity,
           java.lang.String                alias,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamUnassignedAliasException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listAliases() method on the Parlay Gateway.
     */
    java.lang.String[] listAliases(
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the lookupByAlias() method on the Parlay Gateway.
     */
    java.lang.String lookupByAlias(
           java.lang.String                alias,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAliasException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the associateTypes() method on the Parlay Gateway.
     */
    void associateTypes(
           java.lang.String                identity,
           java.lang.String[]              identityTypes,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamTypeAssociatedException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the disassociateTypes() method on the Parlay Gateway.
     */
    void disassociateTypes(
           java.lang.String                identity,
           java.lang.String[]              identityTypes,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamDisassociatedTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listTypesOfIdentity() method on the Parlay Gateway.
     */
    java.lang.String[] listTypesOfIdentity(
           java.lang.String                identity,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the hasType() method on the Parlay Gateway.
     */
    boolean hasType(
           java.lang.String                identity,
           java.lang.String                typeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the getIdentityAttributes() method on the Parlay Gateway.
     */
    org.csapi.jr.se.pam.PAMAttribute[] getIdentityAttributes(
           java.lang.String                identity,
           java.lang.String                identityType,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the setIdentityAttributes() method on the Parlay Gateway.
     */
    void setIdentityAttributes(
           java.lang.String                identity,
           java.lang.String                identityType,
           org.csapi.jr.se.pam.PAMAttribute[] attributes,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownIdentityException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownAttributesException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

}
