//Source file: PAMIdentityTypeManagement.java
//Date: February 2004
//Presence and Availability Management Interfaces for 3GPP TS 29.198-14 V6.0.0, Release 6

package org.csapi.jr.se.pam.provisioning;

/**
 * This interface represents a PAMIdentityTypeManagement.<BR>
 *
 */
public interface PAMIdentityTypeManagement extends org.csapi.jr.se.Service {

    /**
     * Invokes the createIdentityAttribute() method on the Parlay Gateway.
     */
    void createIdentityAttribute(
           org.csapi.jr.se.pam.PAMAttributeDef pAttribute,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamAttributeExistsException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the deleteIdentityAttribute() method on the Parlay Gateway.
     */
    void deleteIdentityAttribute(
           java.lang.String                attributeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the getIdentityAttributeDefinition() method on the Parlay Gateway.
     */
    org.csapi.jr.se.pam.PAMAttributeDef getIdentityAttributeDefinition(
           java.lang.String                attributeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listAllIdentityAttributes() method on the Parlay Gateway.
     */
    java.lang.String[] listAllIdentityAttributes(
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the createIdentityType() method on the Parlay Gateway.
     */
    void createIdentityType(
           java.lang.String                typeName,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamTypeExistsException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the deleteIdentityType() method on the Parlay Gateway.
     */
    void deleteIdentityType(
           java.lang.String                typeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listIdentityTypes() method on the Parlay Gateway.
     */
    java.lang.String[] listIdentityTypes(
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the addIdentityTypeAttributes() method on the Parlay Gateway.
     */
    void addIdentityTypeAttributes(
           java.lang.String                typeName,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamAttributeExistsException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the removeIdentityTypeAttributes() method on the Parlay Gateway.
     */
    void removeIdentityTypeAttributes(
           java.lang.String                typeName,
           java.lang.String[]              attributeNames,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamUnknownAttributeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

    /**
     * Invokes the listIdentityTypeAttributes() method on the Parlay Gateway.
     */
    java.lang.String[] listIdentityTypeAttributes(
           java.lang.String                typeName,
           byte[]                          authToken)
      throws org.csapi.jr.se.PlatformException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.pam.PamUnknownTypeException,
       org.csapi.jr.se.pam.PamInvalidCredentialException;

}
